#ifndef TRIE_H_
#define TRIE_H_

struct trie;

struct trie * trie_new();
void trie_delete(struct trie * trie);

char * trie_insert(struct trie * trie, char * key, void * data);
void * trie_find(struct trie * trie, char * key);
void * trie_remove(struct trie * trie, char * key);

void trie_walk_keys(struct trie * trie, void (*op)(char * k, void * d) );

void trie_dump(struct trie * trie);
void trie_dump_raw(struct trie * trie);

#endif
